/*
 * PM - 2017
 * lab0.c
 */

#define F_CPU 16000000

#include <avr/interrupt.h>
#include <stdio.h>
#include <stdlib.h>

#include <avr/io.h>
#include <util/delay.h>
#include "rtc.h"



void delay(void)
{
	
	unsigned int del=70;
	_delay_us(del);
	_delay_us(del);
	_delay_us(del);
	_delay_us(del);
}

void display_number(int car)
{

	switch(car)
	{

		case 0:

			PORTB = 0xff;  delay( );
			PORTB	= 0x81;  delay( );
			PORTB	= 0x81;  delay( );
			PORTB	= 0x81;  delay( );
			PORTB	= 0xff;  delay( );
			PORTB = 0xff;  delay( );

			break;

		case 1:

			PORTB = 0x00;  delay( );
			PORTB	= 0x00;  delay( );
			PORTB	= 0x00;  delay( );
			PORTB	= 0x00;  delay( );
			PORTB	= 0xff;  delay( );
			PORTB = 0xff;  delay( );

			break;
		case 2:

			PORTB = 0x39;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0x00;  delay( );
			PORTB = 0xff;  delay( );

			break;

		case 3:

			PORTB = 0x45;  delay( );
			PORTB	= 0x45;  delay( );
			PORTB	= 0x45;  delay( );
			PORTB	= 0x45;  delay( );
			PORTB	= 0xff;  delay( );
			PORTB = 0xff;  delay( );

			break;

		case 4:

			PORTB = 0x0f;  delay( );
			PORTB	= 0x08;  delay( );
			PORTB	= 0x08;  delay( );
			PORTB	= 0x08;  delay( );
			PORTB	= 0xf8;  delay( );
			PORTB = 0xff;  delay( );

			break;

		case 5:

			PORTB = 0x21;  delay( );
			PORTB	= 0x21;  delay( );
			PORTB	= 0x21;  delay( );
			PORTB	= 0x21;  delay( );
			PORTB	= 0xf8;  delay( );
			PORTB = 0xff;  delay( );

			break;

		case 6:

			PORTB = 0xff;  delay( );
			PORTB	= 0x21;  delay( );
			PORTB	= 0x21;  delay( );
			PORTB	= 0x21;  delay( );
			PORTB	= 0xf8;  delay( );
			PORTB = 0xff;  delay( );

			break;

		case 7:

			PORTB = 0x01;  delay( );
			PORTB	= 0x01;  delay( );
			PORTB	= 0x01;  delay( );
			PORTB	= 0x01;  delay( );
			PORTB	= 0xff;  delay( );
			PORTB = 0xff;  delay( );

			break;

		case 8:

			PORTB = 0xff;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0xff;  delay( );
			PORTB = 0xff;  delay( );

			break;

		case 9:

			PORTB = 0x21;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0x49;  delay( );
			PORTB	= 0xff;  delay( );
			PORTB = 0xff;  delay( );
			break;
		default:
			PORTB=0xfe;
	}
}

int main(void) {
//	exemplu();
	
	
	DDRB |= 0xFF;

	
	sei(); // interrupt enable 
	struct rtc_time ds1302;
	struct rtc_time *rtc;
	int led;

	rtc = &ds1302;
	
	ds1302_init();
	ds1302_update(rtc);   // update all fields in the struct
	ds1302_set_time(rtc, SEC, 0);	//set the seconds to 31
	
	while (1)   // read seconds and send it via uart continuously
	{
		ds1302_update_time(rtc, SEC);	//read the seconds
		
		
		display_number((int)rtc->second % 10);
		



		_delay_ms(950);
	}
	return 0;
}
